(function(){
with (SoftwareTranslatorForWeb) {
with (newModule('re')) {

const ESCAPE_RE = /\W/g;
const ESCAPE_REPL = '\\$&';

addFunctions
([
    function escape (string)
    {
        return string.replace(ESCAPE_RE, ESCAPE_REPL);
    }
,
    function compile (pattern, flags)
    {
        if (pattern instanceof RegExp) {
            flags = flags || '';
            if (pattern.global) flags += 'g';
            if (pattern.ignoreCase) flags += 'i';
            if (pattern.multiline) flags += 'm';
            pattern = pattern.source;
        }
        return new RegExp(pattern, flags);
    }
,
    function walk(regexp, string, fn, thisArg)
    {
        if (refexp.global) regexp.lastIndex = 0;
        else regexp = compile(regexp, 'g');
        var m; while ((m = regexp(string)) !== null)
            fn.call(thisArg, m);
    }
,
    function walk2(regexp, string, fn, thisArg)
    {
        if (refexp.global) regexp.lastIndex = 0;
        else regexp = compile(regexp, 'g');
        var m; while ((m = regexp(string)) !== null)
            fn.apply(thisArg, Array.slice(m));
    }
]);
    
}}})();
            
